﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{

	import com.as3facileexemple.skin.classic.DefaultToolTipSkin;
	import com.actionscriptfacile.ui.button.Button;
	import com.actionscriptfacile.ui.tooltip.Tooltip;
	import com.as3facileexemple.skin.classic.DefaultListSkin;
	import flash.display.Shape;
	import com.actionscriptfacile.ui.list.List;
	import com.actionscriptfacile.ui.combo.element.ComboBoxElement;
	import com.actionscriptfacile.ui.utils.UIMargins;
	import com.as3facileexemple.skin.classic.DefaultComboBoxSkin;
	import com.actionscriptfacile.ui.combo.ComboBox;
	import com.actionscriptfacile.ui.text.UITextField;
	import com.debug.Out;

	import flash.events.MouseEvent;
	import flash.display.Sprite;
	import flash.events.Event;

	import com.demonsters.debugger.MonsterDebugger;

	public class Main extends Sprite
	{
		private var nNum : Number;
		
		private var nPosX:Number;
		private var nPosY:Number;
		
		/**
		 * Constructeur.
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 40
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);

			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start Application");
			
			nPosX = 20;
			nPosY = 33;
			
			// utilisation du composant AS3 Facile UITextField
			this.addOutUITextField();// init du debug simple
			
			// utilisation du composant AS3 Facile ComboBox
			this.addComboBox();
			
			// utilisation du composant AS3 Facile List
			this.addList();
			
			// utilisation du composant AS3 Facile Button
			var oButton:Button = this.addButton();
			
			// utilisation du composant AS3 Facile ToolTip
			this.addToolTip(oButton);
	
			Out.trace("Application AS3 Facile ready !");
		}
		
		
		/**
		 * Utilisation du composant AS3 Facile UITextField.
		 * Ajout de la classe de sortie debug.
		 * 
		 */
		private function addOutUITextField() : void
		{
			nNum = 0;
			var oTextDebug:UITextField = new UITextField();
			oTextDebug.x = nPosX;
			oTextDebug.y = 200;
			
			oTextDebug.maxWidth = oTextDebug.width = 433;
			oTextDebug.maxHeight = oTextDebug.height = 163;
			oTextDebug.text = "";

			oTextDebug.convertToDynamic();
			oTextDebug.alignLeft();
			
			oTextDebug.border = true;
			oTextDebug.changeFormat("size", 13);
			oTextDebug.changeFormat("font", "Arial");
			oTextDebug.changeFormat("color", Math.random() * 0X00FFFFFF);
			
			Out.stage = stage;
			Out.textField = oTextDebug;
			Out.maxLength = 1333;// longueur maximum
			
			addChild(oTextDebug);
		}
		
		
		/**
		 * Utilisation du composant AS3 Facile Button.
		 * 
		 */
		private function addButton() : Button
		{
			// notre application
			var oBtnAddStatus:DefaultButton = new DefaultButton();
			oBtnAddStatus.getObject().label = "Ajouter Debug";
			oBtnAddStatus.getObject().x = nPosX;
			oBtnAddStatus.getObject().y = nPosY;
			oBtnAddStatus.getObject().addEventListener(MouseEvent.CLICK, onClickBtn);
			
			addChild(oBtnAddStatus);
			
			return oBtnAddStatus.getObject();
		}
		
		/**
		 * Action de l'utilisateur après le click sur le Button.
		 * 
		 */
		private function onClickBtn(event : MouseEvent) : void
		{
			nNum++;
			Out.trace(nNum+" - Click // Ctrl + D pour masquer / afficher le debug");
		}
		
		
		/**
		 * Utilisation du composant AS3 Facile ToolTip.
		 * 
		 */
		private function addToolTip(oComponent:Button) : void
		{
			/**
			 * On construit son tooltip
			 */
			oComponent.tooltip = new Tooltip();
			oComponent.tooltip.applySkin( new DefaultToolTipSkin() );
			
			oComponent.tooltip.label = 'Appuyez sur le Button !';
			oComponent.tooltip.labelField.changeFormat("color", Math.random() * 0X00FFFFFF);// changement de la couleur du texte
			oComponent.tooltip.labelField.changeFormat("size", 12);// changement de la taille de la police du texte
			oComponent.tooltip.labelField.changeFormat("font", "Arial");// changement de la police du texte
			oComponent.tooltip.resize( 210, 30 );
			
			// position du ToolTip
			oComponent.tooltip.x = oComponent.x + oComponent.width/3;
			oComponent.tooltip.y = oComponent.y - oComponent.height*2.5;
		}
		
		/**
		 * Utilisation du composant AS3 Facile List.
		 * 
		 */
		private function addList() : void
		{
			// création d'une liste
			var oList:List = new List();
			
			// Application de la skin par défaut 
			// [ Attention ! Cette skin utilise le fichier ui.swc qui doit être ajouté à la liste des composants à passer au compilateur ]
			oList.applySkin( new DefaultListSkin() );
			
			// définition de la taille de la List
			oList.resize( 230, 150 );
			
			// ajout de plusieurs éléments dans la liste
			for ( var i:int = 0; i < 35; i++ )
			{
				oList.addElement( getListElement(i+1) );
			}
			
			// détermination de la position de la List
			oList.x = nPosX + 230;
			oList.y = nPosY;
			
			// ajout des marges au contenu de la liste
			oList.margins = new UIMargins( 5, 5, 5, 5 );
			
			// affichage - ajout à la displaylist
			addChild( oList );
		}
		
		/**
		 * Création des éléments du composant List
		 */
		private function getListElement(id:Number):Sprite
		{
			// création de l'élément
			var oElement:Sprite = new Sprite();
			
			// ajout d'un fond avec une couleur aléatoire
			var shp:Shape = new Shape();
			var color:int = Math.random() * 0X00FFFFFF;
			
			shp.graphics.beginFill( color );
			shp.graphics.drawRect( 0, 0, 200, 30 );
			shp.graphics.endFill();
			
			// ajout d'un texte
			var oTxt:UITextField = new UITextField();
			
			// définition de la taille du texte
			oTxt.height = oTxt.maxHeight = 25;
			oTxt.width = oTxt.maxWidth = 195;
			
			oTxt.text = "Élément "+id;
			oTxt.selectable = false;
			oTxt.changeFormat("color", 0xffffff);// changement de la couleur du texte
			oTxt.changeFormat("size", 14);// changement de la taille de la police du texte
			oTxt.changeFormat("font", "Arial");// changement de la police du texte
			
			oTxt.alignCenter();
			
			oTxt.background = false;
			oTxt.backgroundColor = 0xff33ff;
			
			
			// ajout à la displaylist (le fond et le texte) de l'élément
			oElement.addChild(shp);
			oElement.addChild(oTxt);
			
			return oElement;
		}
		
		/**
		 * Utilisation du composant AS3 Facile ComboBox.
		 * 
		 */
		private function addComboBox() : void
		{
			// Création de la combobox qui contient les différentes qualité de la vidéo
			var oComboBox:ComboBox = new ComboBox();
			oComboBox.applySkin( new DefaultComboBoxSkin() );
			// Définition du format du Titre de la ComboBox
			oComboBox.currentLabel = "Qualité : ";
			oComboBox.currentElement.labelField.changeFormat("font", "Arial",-1,-1,true);
            oComboBox.currentElement.labelField.changeFormat("color", Math.random() * 0X00FFFFFF,-1,-1,true);
            oComboBox.currentElement.labelField.changeFormat("size", 15,-1,-1,true);
            oComboBox.currentElement.labelField.changeFormat("bold", true,-1,-1,true);
            oComboBox.currentElement.labelField.alignCenter();
			
			// choix de l'ouverture de la Liste déroulante sous la ComboBox
			oComboBox.scrollDirection = ComboBox.SCROLL_BOTTOM;
			
			oComboBox.resize(100, 40);
			oComboBox.x = nPosX + 120;
			oComboBox.y = nPosY;
			oComboBox.componentsHeight = 25;// hauteur des éléments de la CombobBox
            oComboBox.margins = new UIMargins( 2, 2, 2, 2 );// ajout des marges au contenu de la liste
			oComboBox.addEventListener(Event.CHANGE, onComboBoxChangeHandler ); 
			
			addChild(oComboBox);
			
			
			// ajout d'éléments dans la ComboBox
			var boxElement:ComboBoxElement;
			for (var i : int = 0; i < 34; i++)
            {
                boxElement = oComboBox.addElement( "Valeur N°: "+i, i );
                boxElement.labelField.changeFormat("font", "Arial");// changement de la couleur du texte
                boxElement.labelField.changeFormat("color", Math.random() * 0X00FFFFFF);// changement de la couleur du texte
                boxElement.labelField.changeFormat("size", 12);// changement de la taille de la police du texte
            }
		}
		
		/**
		 * Appuie la combobox par l'utilisateur.
		 * 
		 */
		private function onComboBoxChangeHandler(event : Event) : void
		{
			var qualityLevel : String = event.target.currentLabel;
			MonsterDebugger.trace(this, "onComboBoxChangeHandler : "+qualityLevel);
			Out.trace("Click ComboBox, valeur : "+qualityLevel);
		}

		
		
	}
}
